<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<ng-container *ngLet="(loading$ | async) ?? false as loading">
  <ng-container *ngLet="(contractIdentities$ | async) ?? [] as contractIdentities">
    <ng-container *ngLet="exigentOnly$ | async as exigentOnly">
      <app-contracts-list
        [contractIdentities]="contractIdentities"
        [selectable]="true"
        (onSelectionChange)="onSelectionChange($event)"
        (onDownloadChunkOfIdentities)="onDownloadChunkOfIdentities($event)"
        emptyMessage="No pending contracts"
      >
        <ng-template #options let-contract>
          <app-spinner *ngIf="loading" [size]="16"></app-spinner>
          <app-pending-contract-actions
            *ngIf="!loading && contract"
            [contract]="contract"
          ></app-pending-contract-actions>
        </ng-template>
        <ng-template #selectionAction>
          <div class="w-full flex justify-between items-center">
            <div class="flex items-center shrink-0">
              <p-button
                *ngIf="selectedContracts.length > 0"
                [link]="true"
                [label]="labelAccept"
                [loading]="loading"
                (onClick)="acceptSelection()"
                size="small"
                severity="success"
                icon="pi pi-check"
              ></p-button>
              <p-button
                *ngIf="selectedContracts.length > 0"
                [link]="true"
                [label]="labelReject"
                [loading]="loading"
                (onClick)="revokeSelection()"
                size="small"
                severity="danger"
                icon="fa fa-trash-can"
              ></p-button>
            </div>

            <ng-container *ngLet="exigentOnly === null as filterInactive">
              <ng-container *ngLet="exigentOnly === true || exigentOnly === false as filterActive">
                <div class="w-full flex items-center justify-end gap-2">
                  <div
                    [ngClass]="{ 'filter-button-active': filterInactive, 'filter-button-inactive': filterActive }"
                    (click)="clearFilter()"
                  >
                    All
                  </div>
                  <div
                    [ngClass]="{ 'filter-button-active': filterActive, 'filter-button-inactive': filterInactive }"
                    (click)="menu.toggle($event)"
                  >
                    <div class="flex items-center gap-2">
                      <i *ngIf="filterInactive" class="fa fa-sliders" style="font-size: 0.8rem"></i>
                      <i *ngIf="filterActive" class="pi pi-pencil" style="font-size: 0.8rem"></i>
                      <div>Filter</div>
                    </div>
                  </div>
                </div>
                <p-menu #menu [model]="filterOptions" [popup]="true" appendTo="body">
                  <ng-template pTemplate="item" let-item>
                    <a pRipple class="p-menuitem-link">
                      <p-tag severity="warning" [value]="item.label"></p-tag>
                    </a>
                  </ng-template>
                </p-menu>
              </ng-container>
            </ng-container>
          </div>
        </ng-template>
      </app-contracts-list>
    </ng-container>
  </ng-container>
</ng-container>
